# Repzo API - Approvals - TypeScript Examples

This document provides TypeScript usage examples for the Repzo API - Approvals API using the Repzo SDK.

## Installation

```bash
npm install repzo
```

## Basic Setup

```typescript
import { Service } from "repzo";

// Initialize with your API key
const apiKey = "your-api-key";
const baseURL = "https://api.repzo.me/v1";
```

## API Usage Examples

### Find approvals

```typescript
// GET /approvals

const params = {
  params: null, // Query parameters for filtering approvals
};

const result = await fetch(
  `${baseURL}/approvals?${new URLSearchParams(params)}`,
  {
    method: "GET",
    headers: {
      Authorization: `Bearer ${apiKey}`,
      "Content-Type": "application/json",
    },
  },
);

const data = await result.json();
console.log(data);
```

**Expected Response:**

```json
{
  "success": true,
  "data": {
    // Response data structure based on API specification
  }
}
```

---

### Create an approval

```typescript
// POST /approvals

const requestBody = {
  // Add your request body properties here
  // Based on the API schema
};

const result = await fetch(`${baseURL}/approvals`, {
  method: "POST",
  headers: {
    Authorization: `Bearer ${apiKey}`,
    "Content-Type": "application/json",
  },
  body: JSON.stringify(requestBody),
});

const data = await result.json();
console.log(data);
```

---

### Get an approval by ID

```typescript
// GET /approvals/{id}

const params = {
  id: "example-value", // No description
};

const result = await fetch(
  `${baseURL}/approvals/{id}?${new URLSearchParams(params)}`,
  {
    method: "GET",
    headers: {
      Authorization: `Bearer ${apiKey}`,
      "Content-Type": "application/json",
    },
  },
);

const data = await result.json();
console.log(data);
```

**Expected Response:**

```json
{
  "success": true,
  "data": {
    // Response data structure based on API specification
  }
}
```

---

### Update an approval

```typescript

```

**Expected Response:**

```json
{
  "success": true,
  "data": {
    // Response data structure based on API specification
  }
}
```

---

### Remove an approval

```typescript
// DELETE /approvals/{id}

const id = "your-resource-id";
const deletePath = "/approvals/{id}".replace("{id}", id);

const result = await fetch(`${baseURL}${deletePath}`, {
  method: "DELETE",
  headers: {
    Authorization: `Bearer ${apiKey}`,
    "Content-Type": "application/json",
  },
});

const data = await result.json();
console.log(data);
```

**Expected Response:**

```json
{
  "success": true,
  "data": {
    // Response data structure based on API specification
  }
}
```

---

## Using with Repzo SDK Service Types

The Repzo SDK provides TypeScript interfaces for type safety:

```typescript
import { Service } from "repzo";

// Example using SDK types

async function example() {
  // Use the Service.Approvals types for better type safety
  // This provides intellisense and compile-time type checking
}
```

## Error Handling

```typescript
try {
  const result = await fetch(`${baseURL}/endpoint`, {
    method: "GET",
    headers: {
      Authorization: `Bearer ${apiKey}`,
      "Content-Type": "application/json",
    },
  });

  if (!result.ok) {
    throw new Error(`HTTP error! status: ${result.status}`);
  }

  const data = await result.json();

  if (!data.success) {
    throw new Error(data.error || "API request failed");
  }

  return data.data;
} catch (error) {
  console.error("API request failed:", error);
  throw error;
}
```

## Pagination

Many API endpoints support pagination:

```typescript
const params = {
  page: 1,
  per_page: 25,
  // other filters...
};

const result = await fetch(
  `${baseURL}/endpoint?${new URLSearchParams(params)}`,
  {
    method: "GET",
    headers: {
      Authorization: `Bearer ${apiKey}`,
      "Content-Type": "application/json",
    },
  },
);

const data = await result.json();

// Access pagination info
console.log("Total items:", data.paging.total);
console.log("Current page:", data.paging.page);
console.log("Total pages:", data.paging.pages);
```
